package com.perforce.maven.scm.provider.p4.manager;

import java.io.File;

import org.apache.maven.scm.ScmException;

import com.perforce.maven.scm.provider.p4.repository.P4ScmProviderRepository;
import com.perforce.p4java.client.IClient;

public interface P4ClientManager
{
    /**
     * The Plexus role.
     */
    String ROLE = P4ClientManager.class.getName();

    /**
     * Retrieve a client which can be generated or discovered from client list using the provided server path from 'repo'
     * and 'rootDir'
     *
     * @param repo
     * @param rootDir
     * @return
     * @throws ScmException
     */
    IClient getClient( P4ScmProviderRepository repo, File rootDir )
        throws ScmException;

    /**
     * Retrieve a client with a given clientName
     *
     * @param repo
     * @param rootDir
     * @param clientName
     * @return
     * @throws ScmException
     */
    IClient getClient( P4ScmProviderRepository repo, File rootDir, String clientName )
        throws ScmException;

    /**
     * Discover a client name that matches repo's path and basedir
     *
     * @param repo
     * @param baseDir
     * @return
     */
    String discoverClientName( P4ScmProviderRepository repo, File baseDir )
        throws ScmException;

}
